function oDatastruct=struct2m(varargin)
%   function oDatastruct=struct2m(varargin)
%   converts ecomt-structures and/or double matrices to multi-column ecomt-structures
%   an ecomt-structure is a structure Y with Y.data = matrix of data and Y.name=vector of column names
%____________________________________________________
%OUTPUTS
%   oDatastruct: An Ecomt structure with .data= multiple column matrix and
%       with .name =row vector of column names
%____________________________________________________
%INPUTS
%   As many Ecomt-Structures double matrices as you like
%____________________________________________________
%EXAMPLE
%   e.g. use struct2m(zeros(3,1),ones(3,1))
%______________________________________________________________________
%   Martin Feldkircher & Stefan Zeugner 2006

error(nargchk(1, 1000, nargin))
    counter=0;

for i=1:length(varargin)
    if isstruct(varargin{i})
        for j=1:length(varargin{i})
            csNames=varargin{i}(j).name;
            for k=1:size(varargin{i}(j).data,2)
                counter=counter+1;
                oAlldata(counter).data = varargin{i}(j).data(:,k);
                if iscellstr(csNames)
                    oAlldata(counter).name = char(csNames(:,k));                
                else
                    oAlldata(counter).name =char(csNames);
                end
            end
            %counter=counter+1;
            %oAlldata(counter) = varargin{i}(j);
        end
    elseif isnumeric(varargin{i})
            %counter=counter+1;
            for k=1:size(varargin{i},2)
                counter=counter+1;
                oAlldata(counter).data=varargin{i}(:,k);
                oAlldata(counter).name=strcat('ser',int2str(i),'_',int2str(k));
            end
    else
            error(strcat('input ', int2str(i) , ' is neither numeric array nor structure'))
    end

end

try
    oDatastruct.data=cat(2, oAlldata.data);
    oDatastruct.name=cat(2, {oAlldata.name});
catch
    error('Problem with data: Either matrix dimensions not consistent or input structures not of required type.')
end
